<?php

/**
 * @file
 * Node popup module administration pages functions.
 */

/**
 * Main administration settings page form.
 */
function npop_admin_settings_form($form, $form_state) {
  $node_types = node_type_get_names();
  $form['npop_change_urls'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Change urls on selected node types'),
    '#default_value' => variable_get('npop_change_urls', array()),
    '#description' => t('Allow to change url (by JavaScript History API), for selected node types, when popup window is oppen. This is SEO friendly settings for popup window.'),
    '#options' => $node_types,
  );

  // Allow other modules create animations for popup window.
  $animations = array_map('_npop_fix_css_arrays', module_invoke_all('npop_css_animations'));
  $form['npop_animations'] = array(
    '#type' => 'select',
    '#options' => $animations,
    '#default_value' => variable_get('npop_animations'),
    '#empty_option' => t('Without animation'),
    '#empty_value' => 0,
  );

  // Fitler saved values.
  $form['array_filter'] = array(
    '#type' => 'value',
    '#value' => TRUE,
  );

  return system_settings_form($form);
}

/**
 * The array_map callback functoin, fixed duplicate class names.
 */
function _npop_fix_css_arrays($element) {
  if (is_array($element)) {
    return array_shift($element);
  }
  else {
    return $element;
  }
}
